import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React, { Suspense } from 'react';
import PropTypes from 'prop-types';
import { Route, Switch, Redirect } from 'react-router';
export var RouterOutlet = function RouterOutlet(_ref) {
  var routes = _ref.routes,
      placeholder = _ref.placeholder,
      _props = _objectWithoutPropertiesLoose(_ref, ["routes", "placeholder"]);

  return React.createElement(Switch, null, routes.map(function (route, index) {
    route = resolveFromProps(route, _props);
    return route.redirectTo ? React.createElement(Redirect, {
      key: index,
      from: route.path,
      exact: route.exact,
      strict: route.strict,
      to: route.redirectTo,
      push: route.push
    }) : route.canEnter && !route.canEnter(_extends({}, _props, {
      routes: routes
    }), route) ? React.createElement(Redirect, {
      key: index,
      from: route.path,
      exact: route.exact,
      strict: route.strict,
      to: route.fallback,
      push: route.push
    }) : React.createElement(Route, {
      key: index,
      path: route.path,
      exact: route.exact,
      strict: route.strict,
      render: function render(props) {
        return Suspense ? React.createElement(Suspense, {
          fallback: placeholder || React.createElement("div", null)
        }, React.createElement(route.component, _extends({}, props, {
          routes: route.routes
        }))) : React.createElement(route.component, _extends({}, props, {
          routes: route.routes
        }));
      }
    });
  }));
};

var resolveFromProps = function resolveFromProps(route, props) {
  var resolve = function resolve(val) {
    return typeof val === 'function' ? val(props, route) : val;
  };

  return _extends({}, route, {
    redirectTo: resolve(route.redirectTo),
    fallback: resolve(route.fallback)
  });
};

export var routePropType = PropTypes.shape({
  path: PropTypes.oneOfType([PropTypes.string, PropTypes.arrayOf(PropTypes.string)]),
  exact: PropTypes.bool,
  strict: PropTypes.bool,
  component: PropTypes.oneOfType([PropTypes.func, PropTypes.object]),
  canEnter: PropTypes.func,
  fallback: PropTypes.oneOfType([PropTypes.func, PropTypes.string, PropTypes.object]),
  redirectTo: PropTypes.oneOfType([PropTypes.func, PropTypes.string, PropTypes.object]),
  push: PropTypes.bool
});
RouterOutlet.propTypes = {
  routes: PropTypes.arrayOf(routePropType).isRequired,
  placeholder: PropTypes.oneOfType([PropTypes.func, PropTypes.object])
};
export default RouterOutlet;