"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = exports.routePropType = exports.RouterOutlet = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactRouter = require("react-router");

var RouterOutlet = function RouterOutlet(_ref) {
  var routes = _ref.routes,
      placeholder = _ref.placeholder,
      _props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, ["routes", "placeholder"]);

  return _react["default"].createElement(_reactRouter.Switch, null, routes.map(function (route, index) {
    route = resolveFromProps(route, _props);
    return route.redirectTo ? _react["default"].createElement(_reactRouter.Redirect, {
      key: index,
      from: route.path,
      exact: route.exact,
      strict: route.strict,
      to: route.redirectTo,
      push: route.push
    }) : route.canEnter && !route.canEnter((0, _extends2["default"])({}, _props, {
      routes: routes
    }), route) ? _react["default"].createElement(_reactRouter.Redirect, {
      key: index,
      from: route.path,
      exact: route.exact,
      strict: route.strict,
      to: route.fallback,
      push: route.push
    }) : _react["default"].createElement(_reactRouter.Route, {
      key: index,
      path: route.path,
      exact: route.exact,
      strict: route.strict,
      render: function render(props) {
        return _react.Suspense ? _react["default"].createElement(_react.Suspense, {
          fallback: placeholder || _react["default"].createElement("div", null)
        }, _react["default"].createElement(route.component, (0, _extends2["default"])({}, props, {
          routes: route.routes
        }))) : _react["default"].createElement(route.component, (0, _extends2["default"])({}, props, {
          routes: route.routes
        }));
      }
    });
  }));
};

exports.RouterOutlet = RouterOutlet;

var resolveFromProps = function resolveFromProps(route, props) {
  var resolve = function resolve(val) {
    return typeof val === 'function' ? val(props, route) : val;
  };

  return (0, _extends2["default"])({}, route, {
    redirectTo: resolve(route.redirectTo),
    fallback: resolve(route.fallback)
  });
};

var routePropType = _propTypes["default"].shape({
  path: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].arrayOf(_propTypes["default"].string)]),
  exact: _propTypes["default"].bool,
  strict: _propTypes["default"].bool,
  component: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].object]),
  canEnter: _propTypes["default"].func,
  fallback: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].string, _propTypes["default"].object]),
  redirectTo: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].string, _propTypes["default"].object]),
  push: _propTypes["default"].bool
});

exports.routePropType = routePropType;
RouterOutlet.propTypes = {
  routes: _propTypes["default"].arrayOf(routePropType).isRequired,
  placeholder: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].object])
};
var _default = RouterOutlet;
exports["default"] = _default;